'Updated 11 Oct 2010 - added Win7 compatibillity for specifying .msi file to modify


'Tool for updating default values for the registration information inside the Hugin MSI installer.
'This may be usefull for system administrators deploying applications by Active Directory service

Option Explicit 

'display welcome message
if (MsgBox("Hugin MSI Installer Configuration" + vbCRLF + vbCRLF + "This tool will update the default values for some of the properties in the Hugin installer." + vbCRLF + "The following dialogs will ask for the location of the Hugin installer and the registration information," + vbCRLF + "and optionally lets you specify a new default installation location." + vbCRLF + vbCRLF + "NOTE: The existing Hugin installation MSI-file will be overwritten!", 1, "Hugin MSI Installer Configuration") = 2) then
wscript.quit
end if

'request registration information
dim username, organization, serial, huginroot
username = InputBox("Enter user name", "Hugin MSI Installer Configuration", "-")
organization = InputBox("Enter organization", "Hugin MSI Installer Configuration", "-")
serial = InputBox("Enter serial number", "Hugin MSI Installer Configuration", "XXXX-XXXX")

if (MsgBox("The default target installation path is <program files folder>\Hugin Expert\<package name>." +vbCRLF + vbCRLF + "Do you wish to specify a new target installation path?", 4, "Hugin MSI Installer Configuration") = 6) then
huginroot = InputBox("Enter target installation path:" + vbCRLF + "(path must be absolute, e.g. C:\myapp)", "Hugin MSI Installer Configuration", "")
end if

dim informationOK
dim customPath
customPath = 0
if (Len(huginroot) > 2) then
customPath = 1
else
huginroot = "(Use default path)"
end if
informationOK = 1
if (Len(username) = 0) then
informationOK = 0
end if
if (Len(organization) = 0) then
informationOK = 0
end if
if (Len(serial) <> 9) then
informationOK = 0
end if
if (informationOK = 0) then
MsgBox "The registration information was not entered correct." + vbCRLF + vbCRLF + "Username and organization must be provided." + vbCRLF + "Registration key must be of length 9.", 0, "Hugin MSI Installer Configuration"
wscript.quit
end if


'display MSI selection instructions
if (MsgBox("These are the new settings" +vbCRLF+vbCRLF + "Username: " + username + vbCRLF + "Organization: " + organization + vbCRLF + "Serial: " + serial + vbCRLF + "Target installation path: " + huginroot + vbCRLF + vbCRLF + "Please verify the settings!" + vbCRLF + "(NOTE: The registration information will not be validated by this tool)" +  vbCRLF + vbCRLF + "Press OK to open filechooser and select the Hugin MSI installation file.", 1, "Hugin MSI Installer Configuration") = 2) then
wscript.quit
end if


'display filechooser
Dim objFSO, InitFSO
Dim filename
On Error Resume Next
Set ObjFSO = CreateObject("UserAccounts.CommonDialog") 
if (Err.Number = 0) then
ObjFSO.Filter = "*.msi" 
InitFSO = ObjFSO.ShowOpen
If InitFSO = False Then
MsgBox "You did not select a file!", 0, "Hugin MSI Installer Configuration"
Wscript.Quit
Else
filename = ObjFSO.FileName   
End If
Else
'filechooser component is not available on windows 7 - ask user to enter file path instead
Err.Clear
filename = InputBox("Enter path to .msi file that should be updated:", "Hugin MSI Installer Configuration", "")
End If

'display MSI file overwriting warning
if (MsgBox("File: " + filename + vbCRLF + vbCRLF + "Press OK to update default values for registration information and default target installation path in the Hugin installer" + vbCRLF + vbCRLF + "NOTE: The existing Hugin installation MSI-file will be overwritten!" , 1, "Hugin MSI Installer Configuration") = 2) then
wscript.quit
end if

'update properties USER_NAME ORGANIZATION and SERIAL_NUMBER and HUGINROOT within the MSI file
Const msiOpenDatabaseModeReadOnly = 0 
Const msiOpenDatabaseModeTransact = 1 
Dim openMode : openMode = msiOpenDatabaseModeReadOnly 
openMode = msiOpenDatabaseModeTransact 
Dim installer : Set installer = Nothing 
Set installer = Wscript.CreateObject("WindowsInstaller.Installer") 
Dim database
Set database = installer.OpenDatabase(filename, openMode)
Dim query
Set query = database.OpenView("UPDATE Property SET `Value` = '" + username + "' WHERE `Property` = 'USER_NAME'") 
query.Execute 
Set query = database.OpenView("UPDATE Property SET `Value` = '" + organization + "' WHERE `Property` = 'ORGANIZATION'") 
query.Execute 
Set query = database.OpenView("UPDATE Property SET `Value` = '" + serial + "' WHERE `Property` = 'SERIAL_NUMBER'")
query.Execute 
Set query = database.OpenView("DELETE FROM Property WHERE `Property` = 'HUGINROOT'")
query.Execute 
if (customPath = 1) then
Set query = database.OpenView("INSERT INTO Property (`Property`, `Value`) VALUES ('HUGINROOT', '" + huginroot + "')")
query.Execute 
end if
database.Commit 

'display success message 
MsgBox "Default values in the Hugin installer has been updated!" + vbCRLF + "Please run installer to verify.", 0, "Hugin MSI Installer Configuration"

Wscript.Quit